package com.cs.camerasecure;

import java.io.File;
import java.nio.ByteBuffer;
import java.nio.IntBuffer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Vector;

import com.cs.camerasecure.util.ImageUtils;
import com.cs.camerasecure.util.OptionsUtils;
import com.cs.camerasecure.util.SystemUiHider;
import com.cs.cryptographic.AESCript;
import com.cs.cryptographic.RC4Crypt;

import android.annotation.TargetApi;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.res.TypedArray;
import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.drawable.BitmapDrawable;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.Gallery;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

/**
 * An example full-screen activity that shows and hides the system UI (i.e.
 * status bar and navigation/system bar) with user interaction.
 * 
 * @see SystemUiHider
 */
public class GalleryActivity extends Activity {
	public ImageButton cameraClick;

	final int SELECT_IMAGE = 1300;
	/**
	 * Whether or not the system UI should be auto-hidden after
	 * {@link #AUTO_HIDE_DELAY_MILLIS} milliseconds.
	 */
	private static final boolean AUTO_HIDE = true;

	/**
	 * If {@link #AUTO_HIDE} is set, the number of milliseconds to wait after
	 * user interaction before hiding the system UI.
	 */
	private static final int AUTO_HIDE_DELAY_MILLIS = 3000;

	/**
	 * If set, will toggle the system UI visibility upon interaction. Otherwise,
	 * will show the system UI visibility upon interaction.
	 */
	private static final boolean TOGGLE_ON_CLICK = true;

	/**
	 * The flags to pass to {@link SystemUiHider#getInstance}.
	 */
	private static final int HIDER_FLAGS = SystemUiHider.FLAG_HIDE_NAVIGATION;

	/**
	 * The instance of the {@link SystemUiHider} for this activity.
	 */
	private SystemUiHider mSystemUiHider;
	private ArrayList<File> listOfFiles  = null;
	public ArrayList<File> getListOfFiles() {
		return listOfFiles;
	}

	private static GalleryActivity instance = null;
	static ImageAdapter ia = null;


	public GalleryActivity()
	{
		super();
		instance = this;
	}

	@SuppressWarnings("deprecation")
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_galery);

		final View controlsView = findViewById(R.id.fullscreen_content_controls2);
		final ImageView imgView = (ImageView) findViewById(R.id.imageViewGallery);

		// Set up an instance of SystemUiHider to control the system UI for
		// this activity.
		mSystemUiHider = SystemUiHider.getInstance(this, imgView,
				HIDER_FLAGS);
		mSystemUiHider.setup();
		mSystemUiHider
		.setOnVisibilityChangeListener(new SystemUiHider.OnVisibilityChangeListener() {
			// Cached values.
			int mControlsHeight;
			int mShortAnimTime;

			@Override
			@TargetApi(Build.VERSION_CODES.HONEYCOMB_MR2)
			public void onVisibilityChange(boolean visible) {
				if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.HONEYCOMB_MR2) {
					// If the ViewPropertyAnimator API is available
					// (Honeycomb MR2 and later), use it to animate the
					// in-layout UI controls at the bottom of the
					// screen.
					if (mControlsHeight == 0) {
						mControlsHeight = controlsView.getHeight();
					}
					if (mShortAnimTime == 0) {
						mShortAnimTime = getResources().getInteger(
								android.R.integer.config_shortAnimTime);
					}
					controlsView
					.animate()
					.translationY(visible ? 0 : mControlsHeight)
					.setDuration(mShortAnimTime);
				} else {
					// If the ViewPropertyAnimator APIs aren't
					// available, simply show or hide the in-layout UI
					// controls.
					controlsView.setVisibility(visible ? View.VISIBLE
							: View.GONE);
				}

				if (visible && AUTO_HIDE) {
					// Schedule a hide().
					delayedHide(AUTO_HIDE_DELAY_MILLIS);
				}
			}
		});

		// Set up the user interaction to manually show or hide the system UI.
		imgView.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {				
				if (TOGGLE_ON_CLICK) {
					mSystemUiHider.toggle();
				} else {
					mSystemUiHider.show();
				}
			}
		});

		// Upon interacting with UI controls, delay any scheduled hide()
		// operations to prevent the jarring behavior of controls going away
		// while interacting with the UI.
		findViewById(R.id.dummy_button2).setOnTouchListener(
				mDelayHideTouchListener);

		Intent intent= getIntent(); // gets the previously created intent
		String filePath = intent.getStringExtra("Bitmap"); 

		final Gallery gal = (Gallery) findViewById(R.id.gallery);
		File file = new File(filePath);
		File parentDir = file.getParentFile(); // to get the parent dir 

		listOfFiles = new ArrayList<File>(Arrays.asList(parentDir.listFiles(new FilterPngFiles())));
		Collections.sort(listOfFiles, new ComparatorFileDate() );

		Integer index = listOfFiles.indexOf(file);
		if(ia == null)
		{
			ia = new ImageAdapter(this, listOfFiles, imgView);
		}

		Bitmap picture = ia.getMapBitmap().get(filePath) ;
		if(picture == null)
		{
			picture = BitmapFactory.decodeFile(filePath);
		}

		imgView.setImageBitmap(picture);
		imgView.setBackgroundColor(Color.BLACK);
		Toast.makeText(this, filePath, Toast.LENGTH_SHORT).show();
		gal.setAdapter(ia);

		findViewById(R.id.dummy_button2).setOnClickListener(new OnClickListener() {
			public void onClick(View view) {
				try
				{
					Integer in = gal.getSelectedItemPosition();
					Log.d(GalleryActivity.class.getName(), "getSelectedItemPosition is: " + in.toString());	            	
					String filePath = instance.getListOfFiles().get(in).getAbsolutePath();
					Log.d(GalleryActivity.class.getName(), "getAbsolutePath is: " + filePath);
					Toast.makeText(GalleryActivity.this, getApplication().getText(R.string.txtWaitDecoding) + instance.getListOfFiles().get(in).getName(), Toast.LENGTH_LONG).show();

					//txtView.setText(filePath);
					Bitmap picture = BitmapFactory.decodeFile(filePath);
					byte[] pixelsData = ImageUtils.readPixels(picture);
					
//					int [] iPixels = new int[picture.getWidth()* picture.getHeight()];
//					picture.getPixels(iPixels, 0, picture.getWidth(), 0, 0, picture.getWidth(), picture.getHeight());
//					
//					ByteBuffer byteBuffer = ByteBuffer.allocate(iPixels.length * 4);        
//			        IntBuffer intBuffer = byteBuffer.asIntBuffer();
//			        intBuffer.put(iPixels);
//			        pixelsData = byteBuffer.array();
					
					//bmpEncoded = Bitmap.createScaledBitmap(bmpEncoded, OptionsUtils.getInstance().getWidth(), OptionsUtils.getInstance().getHeight(), false);
//					pixelsData = AESCript.decrypt(OptionsUtils.getInstance().getPass(), pixelsData);
					//ImageUtils.putPixels(bmpEncoded, pixelsData);
					//ImageUtils.saveBitmap(bmpEncoded, file1Path);
					
					
					
					Log.i(GalleryActivity.class.getName(), "SecurityLevel is: " + OptionsUtils.getInstance().getSecurityLevel().toString());
					Log.i(GalleryActivity.class.getName(), "Encrypded password is: " + OptionsUtils.getInstance().getEncryptedPass());
					Log.i(GalleryActivity.class.getName(), "Decrypting with password: " + OptionsUtils.getInstance().getPass());
					pixelsData = RC4Crypt.getInstance().decrypt(OptionsUtils.getInstance().getPass().getBytes("UTF-8"),pixelsData);


					// Si no es una resolucion valida.
					//	    			byte[] dataTemp = new byte[picture.getWidth() * (picture.getHeight() - 1) * 4 + 16];
					//	    			System.arraycopy(pixelsData, 0, dataTemp, 0, dataTemp.length);
					//	    			pixelsData = dataTemp;	    			
					//	    			pixelsData = AESCript.decrypt(OptionsUtils.getInstance().getPass(), pixelsData);

					ImageUtils.putPixels(picture, pixelsData);
					imgView.setImageBitmap(picture);
					imgView.setBackgroundColor(Color.BLACK);

					ImageView imgMiniView = ia.getMapImageView().get(filePath);
					if(imgMiniView == null)
					{
						imgMiniView = (ImageView) ia.getView(in, imgMiniView, null);
					}
					imgMiniView.setImageBitmap(picture);
					imgMiniView.setBackgroundColor(Color.BLACK);
					ia.setImage(filePath, picture);
					ia.notifyDataSetChanged();            	
				} catch(Exception ex)
				{
					if(ex != null)
					{
						Log.e(GalleryActivity.class.getName(), "Error. onClick (decrypt)." + ex.getMessage());
					} else
					{
						Log.e(GalleryActivity.class.getName(), "Error. onClick (decrypt).");
					}
				}
			}
		});


		gal.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View v, int position, long id) {
				Toast.makeText(GalleryActivity.this, instance.getListOfFiles().get(position).getName(), Toast.LENGTH_SHORT).show();
				String path = instance.getListOfFiles().get(position).getAbsolutePath();
				Bitmap picture = ia.getMapBitmap().get(path);
				if(picture == null)
				{
					BitmapFactory.Options options = new BitmapFactory.Options();
					options.inSampleSize = 4;
					picture = BitmapFactory.decodeFile(path, options);
					ia.getMapBitmap().put(path, picture);
				} 

				imgView.setImageBitmap(picture);
				imgView.setBackgroundColor(Color.BLACK);
			}
		});
		gal.setSelection(index, true);
		Log.d(GalleryActivity.class.getName(), listOfFiles.get(index).getName());
	}





	@Override
	protected void onPostCreate(Bundle savedInstanceState) {
		super.onPostCreate(savedInstanceState);

		// Trigger the initial hide() shortly after the activity has been
		// created, to briefly hint to the user that UI controls
		// are available.
		delayedHide(100);
	}

	/**
	 * Touch listener to use for in-layout UI controls to delay hiding the
	 * system UI. This is to prevent the jarring behavior of controls going away
	 * while interacting with activity UI.
	 */
	View.OnTouchListener mDelayHideTouchListener = new View.OnTouchListener() {
		@Override
		public boolean onTouch(View view, MotionEvent motionEvent) {
			if (AUTO_HIDE) {
				delayedHide(AUTO_HIDE_DELAY_MILLIS);
			}
			return false;
		}
	};

	Handler mHideHandler = new Handler();
	Runnable mHideRunnable = new Runnable() {
		@Override
		public void run() {
			mSystemUiHider.hide();
		}
	};

	/**
	 * Schedules a call to hide() in [delay] milliseconds, canceling any
	 * previously scheduled calls.
	 */
	private void delayedHide(int delayMillis) {
		mHideHandler.removeCallbacks(mHideRunnable);
		mHideHandler.postDelayed(mHideRunnable, delayMillis);
	}

	public class ImageAdapter extends BaseAdapter {
		private static final int ITEM_WIDTH = 136;
		private static final int ITEM_HEIGHT = 88;
		private Map<String, ImageView> map = new HashMap<String, ImageView>();
		private Map<String, Bitmap> mapBitmap = new HashMap<String, Bitmap>();
		private final int mGalleryItemBackground;
		private final Context mContext;
		private ImageView imageViewBig = null;
		private ArrayList<File> mImageIds = null;
		private final float mDensity;


		public ImageAdapter(Context c, ArrayList<File> pictures, ImageView imgView) {
			mContext = c;
			mImageIds = pictures;
			imageViewBig = imgView;
			// See res/values/attrs.xml for the <declare-styleable> that defines
			// Gallery1.
			TypedArray a = obtainStyledAttributes(R.styleable.Gallery1);
			mGalleryItemBackground = a.getResourceId(
					R.styleable.Gallery1_android_galleryItemBackground, 0);
			a.recycle();

			mDensity = c.getResources().getDisplayMetrics().density;
		}

		public Map<String, ImageView> getMapImageView()
		{
			return this.map;
		}

		public Map<String, Bitmap> getMapBitmap()
		{
			return this.mapBitmap;
		}

		public int getCount() {
			return mImageIds.size();
		}

		public Object getItem(int position) {
			return position;
		}

		public long getItemId(int position) {
			return position;
		}

		public void setImage(String path, Bitmap bmp)
		{
			mapBitmap.put(path, bmp);
		}

		@SuppressWarnings("deprecation")
		public View getView(int position, View convertView, ViewGroup parent) {
			ImageView imageView = null;
			try
			{
				if (convertView == null) {
					convertView = new ImageView(mContext);

					imageView = (ImageView) convertView;
					imageView.setScaleType(ImageView.ScaleType.FIT_XY);
					imageView.setLayoutParams(new Gallery.LayoutParams(
							(int) (ITEM_WIDTH * mDensity + 0.5f),
							(int) (ITEM_HEIGHT * mDensity + 0.5f)));

					// The preferred Gallery item background	                	                
				} else {
					imageView = (ImageView) convertView;
				}

				imageView.setBackgroundResource(mGalleryItemBackground);
				String path = mImageIds.get(position).getAbsolutePath();
				Bitmap picture = mapBitmap.get(path);
				if(picture == null)
				{
					BitmapFactory.Options options = new BitmapFactory.Options();
					options.inSampleSize = 4;
					picture = BitmapFactory.decodeFile(path, options);
				}

				imageView.setImageBitmap(picture);
				imageView.setBackgroundColor(Color.BLACK);	

			} catch(Exception ex)
			{
				Log.e(GalleryActivity.class.getName(), "Error: " + ex.getMessage());
			}
			return imageView;
		}
	}
}
