package com.cs.camerasecure.util;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.IntBuffer;
import java.text.SimpleDateFormat;
import java.util.Date;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Log;

import com.cs.cryptographic.AESCript;

public class ImageUtils 
{
	public static void fillPixels(int [] pixels, int color)
	{
		for(int i = 0; i < pixels.length; i++)
		{
			pixels[i] = color;
		}
	}
	
	public static String buildFileName()
	{
//		java.util.Date date = new java.util.Date(); 
//		java.text.SimpleDateFormat sdf=new java.text.SimpleDateFormat("yyyy_MM_dd_HH_mm_ss");
		String filename = 
		        new SimpleDateFormat("yyyyMMdd_HHmmss").format(new Date());
//		String fecha = sdf.format(date);
//		String filename = fecha + ".jpg";
		return filename + ".png";
	}
	
	public static void pritPixels(Bitmap bitmap)
	{		
		int [] pixels = new int[bitmap.getWidth() * bitmap.getHeight()];
		
		bitmap.getPixels(pixels, 0, bitmap.getWidth(), 0, 0, bitmap.getWidth(), bitmap.getHeight());
		Log.d(ImageUtils.class.getName(), "Pixels : " + pixels.hashCode());
		for(Integer x = 0; x < pixels.length; x++)
		{
			Log.d(ImageUtils.class.getName(), x.toString() + ": " + new Integer(pixels[x]).toString());				
		}
	}
	
	public static void printBytes(int [] data)
	{
		printBytes(AESCript.getBytes(data), 0);
	}
	
	public static void printBytes(byte []data, int len)
	{
		len = len < 16 ?  16 : len;
		Log.d(ImageUtils.class.getName(), "-");
		for(Integer i = 0; i < len; i++)
		//if(data.length == 480000)
		//	return;
		//for(Integer i = 480000; i < 480064; i++)
		{
			Log.d(ImageUtils.class.getName(), new Integer(data[i]).toString() + ",");
			if((i + 1) % 8 == 0)
			{
				Log.d(ImageUtils.class.getName(), "\n");
			} else if((i + 1) % 4 == 0)
			{
				Log.d(ImageUtils.class.getName(), "  ");
			}
		}
		Log.d(ImageUtils.class.getName(), " ");
	}
	
	public static Boolean saveBitmap(Bitmap bmp, String path) throws IOException
	{
		File file = new File(path);
		FileOutputStream fOut = new FileOutputStream(file);
		Boolean bCompress = bmp.compress(Bitmap.CompressFormat.PNG, 100, fOut);
		//fOut.flush();
		fOut.close();
		Log.d(ImageUtils.class.getName(), "Save bitmap " + path + ": " + bCompress.toString());
		return bCompress;
	}
	
	public static byte[] readPixels(Bitmap bmp)
	{
		//int [] pixelsInt = new int[bmp.getWidth() * bmp.getHeight()];
		byte[] pixels = new byte[bmp.getWidth() * bmp.getHeight() * 4];
		ByteBuffer pixelBytepBuffer = ByteBuffer.allocate(pixels.length);					
		bmp.copyPixelsToBuffer(pixelBytepBuffer);
		printBytes(pixelBytepBuffer.array(), 32);		
		return pixelBytepBuffer.array();
	}
	
	public static byte[] readPixels2(Bitmap bmp)
	{
		int[] pixels = new int[bmp.getWidth() * bmp.getHeight()];
		ByteBuffer bb = ByteBuffer.allocate(pixels.length * 4);
		IntBuffer ib =  bb.asIntBuffer();
		
		bmp.getPixels(pixels, 0, bmp.getWidth(), 0, 0, bmp.getWidth(), bmp.getHeight());
		ib.put(pixels);
		ib.flip();
		return bb.array();
	}
	
	public static void putPixels2(Bitmap bmp, byte[] pixels)
	{
		ByteBuffer bb = ByteBuffer.allocate(pixels.length);
		bb.put(pixels);
		//bb.flip();
		IntBuffer ib =  bb.asIntBuffer();
		bmp.setPixels(ib.array(),  0, bmp.getWidth(), 0, 0, bmp.getWidth(), bmp.getHeight());
	}
	
	public static void putPixels(Bitmap bmp, byte[] pixels)
	{
		ByteBuffer buf = ByteBuffer.allocate(pixels.length);
		buf.put(pixels);
		buf.flip();
		bmp.copyPixelsFromBuffer(buf);
		printBytes(pixels, 32);
	}
	
	public static Bitmap getMutableBitmap(String path)
	{
		BitmapFactory.Options options = new BitmapFactory.Options();
		//options.inMutable = true;
		options.inScaled = false;
		Bitmap bmpUnmutable = BitmapFactory.decodeFile(path, options);
		// Obtenemos un Bitmap mutable a partir de la imagen anterior.
		Bitmap bmpMutable = bmpUnmutable.copy(Bitmap.Config.ARGB_8888, true);
		bmpMutable.setHasAlpha(true);
		return bmpMutable;
	}
}
