package com.cs.cryptographic;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.IntBuffer;
import java.security.SecureRandom;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;

import android.util.Log;

import com.cs.camerasecure.util.ImageUtils;

public class AESCript 
{
	private static byte[] encrypt(byte[] raw, byte[] clear) throws Exception {
        SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
        Cipher cipher = Cipher.getInstance("AES");
        cipher.init(Cipher.ENCRYPT_MODE, skeySpec);
        byte[] encrypted = cipher.doFinal(clear);
        Log.d(AESCript.class.getName(), "Size encrypt: " + raw.length);
        Log.d(AESCript.class.getName(), "Encrypt size: " + clear.length);
        return encrypted;
    }
	
	public static byte[] decrypt(String pass, byte[] pixels) throws Exception {
		byte[] keyStart = pass.getBytes("UTF-8");
	    KeyGenerator kgen = KeyGenerator.getInstance("AES");
	    // http://stackoverflow.com/questions/13383006/encryption-error-on-android-4-2
	    SecureRandom sr = SecureRandom.getInstance("SHA1PRNG", "Crypto");
	    sr.setSeed(keyStart);
	    kgen.init(128, sr); // 192 and 256 bits may not be available
	    SecretKey skey = kgen.generateKey();
	    
		return decrypt(skey.getEncoded(), pixels);
	}
	
	public static byte[] encrypt(String pass, byte[] pixels) throws Exception {
		byte[] keyStart = pass.getBytes("UTF-8");
	    KeyGenerator kgen = KeyGenerator.getInstance("AES");
	    // http://stackoverflow.com/questions/13383006/encryption-error-on-android-4-2
	    SecureRandom sr = SecureRandom.getInstance("SHA1PRNG", "Crypto");
	    sr.setSeed(keyStart);
	    kgen.init(128, sr); // 192 and 256 bits may not be available
	    SecretKey skey = kgen.generateKey();	  
	    return encrypt(skey.getEncoded(), pixels);
	}
	
	public static int[] encrypt(String pass, int[] pixels, int  width, int height) throws Exception {
		int[] data =  encrypt(pass, pixels);
		int[] datapad = new int[9];
		System.arraycopy(data, 0, datapad, 0, data.length);
		
		return datapad;
	}
	
	public static byte[] encrypt(String pass, byte[] pixels, int  width, int height) throws Exception {
		byte[] data = encrypt(pass, pixels);
		byte[] datapad = new byte[9 * 4];
		System.arraycopy(data, 0, datapad, 0, data.length);
		
		return datapad;
	}
	
	public static int[] encrypt(String pass, int[] pixels) throws Exception {
		// Pasamos los pixels de int[] a byte[]
//		ByteBuffer byteBuffer = ByteBuffer.allocate(pixels.length * 4);        
//	    IntBuffer intBuffer = byteBuffer.asIntBuffer();
//	    intBuffer.put(pixels);
	    
	    // Obenemos el array de bytes de la contrasea;
	    byte[] keyStart = pass.getBytes("UTF-8");
	    KeyGenerator kgen = KeyGenerator.getInstance("AES");
	    // http://stackoverflow.com/questions/13383006/encryption-error-on-android-4-2
	    SecureRandom sr = SecureRandom.getInstance("SHA1PRNG", "Crypto");
	    sr.setSeed(keyStart);
	    kgen.init(128, sr); // 192 and 256 bits may not be available
	    SecretKey skey = kgen.generateKey();	  
	    
		return getIntegers(encrypt(skey.getEncoded(), getBytes(pixels)));
	}
	
	public static byte[] getBytes(int[] pixels)
	{
		ByteBuffer byteBuffer = ByteBuffer.allocate(pixels.length * 4);        
	    IntBuffer intBuffer = byteBuffer.asIntBuffer();
	    intBuffer.put(pixels);
	    return byteBuffer.array();
	}
	
	public static int[] getIntegers(byte[] data)
	{
		IntBuffer intBuf =
	    		   ByteBuffer.wrap(data).order(ByteOrder.BIG_ENDIAN).asIntBuffer();

		int[] pixels = new int[intBuf.remaining()];
		intBuf.get(pixels);
		return pixels;
	}
	
	public static int[] decrypt(String pass, int[] pixels) throws Exception {
		byte[] keyStart = pass.getBytes("UTF-8");
	    KeyGenerator kgen = KeyGenerator.getInstance("AES");
	    // http://stackoverflow.com/questions/13383006/encryption-error-on-android-4-2
	    SecureRandom sr = SecureRandom.getInstance("SHA1PRNG", "Crypto");
	    sr.setSeed(keyStart);
	    kgen.init(128, sr); // 192 and 256 bits may not be available
	    SecretKey skey = kgen.generateKey();
	    byte[] bDecrypt = decrypt(skey.getEncoded(), getBytes(pixels));
		return getIntegers(bDecrypt);
	}
	
	private static byte[] decrypt(byte[] raw, byte[] encrypted) throws Exception {
//		Log.d(AESCript.class.getName(), "Size decrypt: " + raw.length);
//		Log.d(AESCript.class.getName(), "Decrypt size: " + encrypted.length);
		SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
        Cipher cipher = Cipher.getInstance("AES");
        cipher.init(Cipher.DECRYPT_MODE, skeySpec);
        byte[] decrypted = null;
        try
        {
        	decrypted = cipher.doFinal(encrypted);
        } catch (IllegalBlockSizeException e) {
        	Log.e(AESCript.class.getName(), e.getMessage());
		} catch(BadPaddingException ex)
		{
			Log.e(AESCript.class.getName(), ex.getMessage());
		}
        return decrypted;
    }
}
